/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#ifndef LORENZ95_MODELBIASCTLVEC_H_
#define LORENZ95_MODELBIASCTLVEC_H_

#include <iostream>
#include <vector>

#include "util/Printable.h"

namespace eckit {
  class Configuration;
}

namespace lorenz95 {
  class ModelBias;
  class ModelBiasCovariance;

  /// ModelBiasCtlVec Class
  /*!
   *  Part of the control vector corresponding to the ModelAuxIncrement part of the
   *  control increment
   */

// -----------------------------------------------------------------------------

class ModelBiasCtlVec : public util::Printable {
 public:
/// Constructor, destructor
  ModelBiasCtlVec(const ModelBiasCovariance &) {}
  ModelBiasCtlVec(const ModelBiasCovariance &, const ModelBiasCtlVec &) {}
  ModelBiasCtlVec(const ModelBiasCtlVec &, const bool copy = true) {}
  ~ModelBiasCtlVec() {}

/// Linear algebra operators
  void zero() {}
  ModelBiasCtlVec & operator=(const ModelBiasCtlVec &) {return *this;}
  ModelBiasCtlVec & operator+=(const ModelBiasCtlVec &) {return *this;}
  ModelBiasCtlVec & operator-=(const ModelBiasCtlVec &) {return *this;}
  ModelBiasCtlVec & operator*=(const double) {return *this;}
  void axpy(const double, const ModelBiasCtlVec &) {}
  double dot_product_with(const ModelBiasCtlVec &) const {return 0.0;}

/// I/O and diagnostics
  void read(const eckit::Configuration &) {}
  void write(const eckit::Configuration &) const {}
  double norm() const {return 0.0;}

 private:
  void print(std::ostream &) const {}
};

// -----------------------------------------------------------------------------

}  // namespace lorenz95

#endif  // LORENZ95_MODELBIASCTLVEC_H_
