/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#include "lorenz95/ObsBiasCtlVec.h"

#include <cmath>
#include <iostream>
#include <sstream>
#include <string>

#include "eckit/config/LocalConfiguration.h"
#include "oops/interface/ObsAuxCovarianceBase.h"
#include "util/Logger.h"

using oops::Log;

// -----------------------------------------------------------------------------
namespace lorenz95 {
// -----------------------------------------------------------------------------
static oops::ObsAuxCtlVecMaker<ObsBiasCtlVec> makeObsBiasCtlVec_("ObsBiasL95");
// -----------------------------------------------------------------------------
ObsBiasCtlVec* ObsBiasCtlVec::clone(const oops::ObsAuxCovarianceBase & cov) const {
  return new ObsBiasCtlVec(cov, *this);
}
// -----------------------------------------------------------------------------
ObsBiasCtlVec* ObsBiasCtlVec::clone(const bool copy) const {
  return new ObsBiasCtlVec(*this, copy);
}
// -----------------------------------------------------------------------------
}  // namespace lorenz95
