/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#ifndef OOPS_ASSIMILATION_CHOLDECOMP_H_
#define OOPS_ASSIMILATION_CHOLDECOMP_H_

#include <vector>

#include "util/Logger.h"

extern "C" {
  void FtnCholDecomp(const int &, const double *, double *);
}

namespace oops {

void CholDecomp(const std::vector<double> & mat,
                std::vector<double> & lmat) {
  const int nn2 = mat.size();
  const int nn = sqrt(nn2);
  ASSERT(nn*nn == nn2);
  lmat.resize(nn2);

  if (nn > 0) {
    FtnCholDecomp(nn, &mat[0], &lmat[0]);
  }
}

}  // namespace oops

#endif  // OOPS_ASSIMILATION_CHOLDECOMP_H_
