! (C) Copyright 2009-2016 ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
! In applying this licence, ECMWF does not waive the privileges and immunities 
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

!> Interfaces to be called from C++ for Fortran computation of Cholesky decomposition
!> of a symmetric positive definite matrix.

! ------------------------------------------------------------------------------

subroutine choleskydecomp(cnn, cmat, clmat) bind(c,name='FtnCholDecomp')

use iso_c_binding
use kinds

implicit none
integer(c_int), intent(in)  :: cnn                 !< Size of matrix
real(c_double), intent(in)  :: cmat(cnn,cnn)       !< Matrix
real(c_double), intent(out) :: clmat(cnn,cnn)      !< Lower triangular matrix

real(kind=kind_real) :: zlmat(cnn, cnn)
integer :: nn, info

nn = cnn
zlmat(:,:) = cmat(:,:)

call dpotrf('L', nn, zlmat, nn, info)

if (info/=0) call abor1_ftn("choleskydecomp: Error in dpotrf")

clmat(:,:) = zlmat(:,:)

end subroutine choleskydecomp

! ------------------------------------------------------------------------------

