! (C) Copyright 2009-2016 ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
! In applying this licence, ECMWF does not waive the privileges and immunities 
! granted to it by virtue of its status as an intergovernmental organisation nor
! does it submit to any jurisdiction.

!> Interfaces to be called from C++ for Fortran computation of eigenvalues
!> and eigenvectors of a symetric matrix.

! ------------------------------------------------------------------------------

subroutine symmatev(cnn, cmat, ceval, cevec) bind(c,name='FtnSymMatSpectrum')

use iso_c_binding
use kinds

implicit none
integer(c_int), intent(in)    :: cnn             !< Size of matrix
real(c_double), intent(in)    :: cmat(cnn,cnn)   !< Matrix
real(c_double), intent(inout) :: ceval(cnn)      !< Eigenvalues
real(c_double), intent(inout) :: cevec(cnn,cnn)  !< Eigenvectors

real(kind=kind_real) :: zmat(cnn, cnn)
real(kind=kind_real) :: zeval(cnn)
real(kind=kind_real) :: zwork(3*cnn)
integer :: nn, info

nn = cnn
zmat(:,:) = cmat(:,:)
zwork(:) = 0.0
zeval(:) = 0.0

call dsyev('V', 'L', nn, zmat, nn, zeval, zwork, 3*nn, info)

if (info/=0) call abor1_ftn("symmatev: Error in dsyev")

ceval(:) = zeval(:)
cevec(:,:) = zmat(:,:)

end subroutine symmatev

! ------------------------------------------------------------------------------

