/*
 * (C) Copyright 2009-2016 ECMWF.
 * 
 * This software is licensed under the terms of the Apache Licence Version 2.0
 * which can be obtained at http://www.apache.org/licenses/LICENSE-2.0. 
 * In applying this licence, ECMWF does not waive the privileges and immunities 
 * granted to it by virtue of its status as an intergovernmental organisation nor
 * does it submit to any jurisdiction.
 */

#ifndef OOPS_BASE_STATESAVER_H_
#define OOPS_BASE_STATESAVER_H_

#include "oops/base/PostBase.h"

#include <boost/ptr_container/ptr_vector.hpp>

#include "eckit/config/LocalConfiguration.h"
#include "util/DateTime.h"

namespace oops {

/// Store forecast fields.
/*!
 *  Store forecast fields for late 4D start.
 */

template <typename FLDS> class StateSaver : public PostBase<FLDS> {
 public:
  StateSaver(const eckit::Configuration & conf):
    PostBase<FLDS>(conf), ppConfig_(conf) {}
  ~StateSaver() {}

  std::vector<FLDS> & releaseFields() { return flds_; }

 private:
  const eckit::LocalConfiguration ppConfig_;
  std::vector<FLDS> flds_;
  void doProcessing(const FLDS & xx) override { flds_.push_back(xx); }
};

}  // namespace oops

#endif  // OOPS_BASE_STATESAVER_H_
